#ifndef AHRS_H
#define AHRS_H

#include "AHRS_MiddleWare.h"

/**
  * @brief          ݼٶȵݣƵݽԪʼ
  * @author         luopin
  * @param[in]      ҪʼԪ
  * @param[in]      ڳʼļٶȼ,(x,y,z)Ϊ λ m/s2 
  * @param[in]      ڳʼĴƼ,(x,y,z)Ϊ λ uT
  * @retval         ؿ
  */
extern void AHRS_init(fp32 quat[4], const fp32 accel[3], const fp32 mag[3]);

/**
  * @brief          ǵݣٶȵݣƵݽԪ
  * @author         luopin
  * @param[in]      ҪµԪ
  * @param[in]      ¶ʱʱ䣬̶ʱã1000HzΪ0.001f,
  * @param[in]      ڸµ,˳(x,y,z) λ rad
  * @param[in]      ڳʼļٶ,˳(x,y,z) λ m/s2 
  * @param[in]      ڳʼĴ,˳(x,y,z) λ uT
  * @retval         ؿ
  */
extern bool_t AHRS_update(fp32 quat[4], const fp32 timing_time, const fp32 gyro[3], const fp32 accel[3], const fp32 mag[3]);

/**
  * @brief          ԪСӦŷƫyaw
  * @author         luopin
  * @param[in]      Ԫ飬ΪNULL
  * @retval         صƫyaw λ rad
  */
extern fp32 get_yaw(const fp32 quat[4]);

/**
  * @brief          ԪСӦŷǸ pitch
  * @author         luopin
  * @param[in]      Ԫ飬ΪNULL
  * @retval         صĸ pitch λ rad
  */
extern fp32 get_pitch(const fp32 quat[4]);
/**
  * @brief          ԪСӦŷǺ roll
  * @author         luopin
  * @param[in]      Ԫ飬ΪNULL
  * @retval         صĺ roll λ rad
  */
extern fp32 get_roll(const fp32 quat[4]);

/**
  * @brief          ԪСӦŷyawpitchroll
  * @author         luopin
  * @param[in]      Ԫ飬ΪNULL
  * @param[in]      صƫyaw λ rad
  * @param[in]      صĸpitch  λ rad
  * @param[in]      صĺroll λ rad
  */
extern void get_angle(const fp32 quat[4], fp32 *yaw, fp32 *pitch, fp32 *roll);
/**
  * @brief          صǰٶ
  * @author         luopin
  * @param[in]      
  * @retval         ٶ λ m/s2
  */

extern fp32 get_carrier_gravity(void);

#endif
