/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       AHRS_MiddleWare.c/h
  * @brief      ̬м㣬Ϊ̬ṩغ
  * @note       
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */

#include "AHRS_MiddleWare.h"
#include "AHRS.h"
#include "arm_math.h"
#include "main.h"
/**
  * @brief          ڻȡǰ߶
  * @author         RM
  * @param[in]      ߶ȵָ룬fp32
  * @retval         ؿ
  */

void AHRS_get_height(fp32 *high)
{
    if (high != NULL)
    {
        *high = 0.0f;
    }
}

/**
  * @brief          ڻȡǰγ
  * @author         RM
  * @param[in]      γȵָ룬fp32
  * @retval         ؿ
  */

void AHRS_get_latitude(fp32 *latitude)
{
    if (latitude != NULL)
    {
        *latitude = Latitude_At_ShenZhen;
    }
}

/**
  * @brief          ٿ
  * @author         RM
  * @param[in]      Ҫĸfp32
  * @retval         1/sqrt ĵ
  */

fp32 AHRS_invSqrt(fp32 num)
{
    fp32 halfnum = 0.5f * num;
    fp32 y = num;
    long i = *(long *)&y;
    i = 0x5f3759df - (i >> 1);
    y = *(fp32 *)&i;
    y = y * (1.5f - (halfnum * y * y));
    return y;
}

/**
  * @brief          sin
  * @author         RM
  * @param[in]      Ƕ λ rad
  * @retval         ضӦǶȵsinֵ
  */

fp32 AHRS_sinf(fp32 angle)
{
    return arm_sin_f32(angle);
}
/**
  * @brief          cos
  * @author         RM
  * @param[in]      Ƕ λ rad
  * @retval         ضӦǶȵcosֵ
  */

fp32 AHRS_cosf(fp32 angle)
{
    return arm_cos_f32(angle);
}

/**
  * @brief          tan
  * @author         RM
  * @param[in]      Ƕ λ rad
  * @retval         ضӦǶȵtanֵ
  */

fp32 AHRS_tanf(fp32 angle)
{
    return tanf(angle);
}
/**
  * @brief          32λķǺ asin
  * @author         RM
  * @param[in]      sinֵ1.0fС-1.0f
  * @retval         ؽǶ λ
  */

fp32 AHRS_asinf(fp32 sin)
{

    return asinf(sin);
}

/**
  * @brief          Ǻacos
  * @author         RM
  * @param[in]      cosֵ1.0fС-1.0f
  * @retval         ضӦĽǶ λ
  */

fp32 AHRS_acosf(fp32 cos)
{

    return acosf(cos);
}

/**
  * @brief          Ǻatan
  * @author         RM
  * @param[in]      tanֵеyֵ С
  * @param[in]      tanֵеxֵ С
  * @retval         ضӦĽǶ λ
  */

fp32 AHRS_atan2f(fp32 y, fp32 x)
{
    return atan2f(y, x);
}
