/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       can_receive.c/h
  * @brief      can豸շļͨcanжɽ
  * @note       ļfreeRTOS
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */

#ifndef CANTASK_H
#define CANTASK_H
#include "main.h"

#define CHASSIS_CAN CAN1//ycz
#define GIMBAL_CAN CAN1

/* CAN send and receive ID */
typedef enum
{
    CAN_CHASSIS_ALL_ID = 0x200,
    CAN_3508_M1_ID = 0x201,
    CAN_3508_M2_ID = 0x202,
    CAN_3508_M3_ID = 0x203,
    CAN_3508_M4_ID = 0x204,

    CAN_YAW_MOTOR_ID = 0x205,
    CAN_PIT_MOTOR_ID = 0x206,
    CAN_TRIGGER_MOTOR_ID = 0x207,
    CAN_GIMBAL_ALL_ID = 0x1FF,

} can_msg_id_e;


// CAN commands
typedef enum {
	CAN_PACKET_SET_DUTY = 0,  //ռձģʽ
	CAN_PACKET_SET_CURRENT,   //ģʽ
	CAN_PACKET_SET_CURRENT_BRAKE,  //ɲģʽ
	CAN_PACKET_SET_RPM,            //תģʽ
	CAN_PACKET_SET_POS,            //λģʽ
	CAN_PACKET_SET_ORIGIN_HERE,    //ԭ
	CAN_PACKET_SET_POS_SPD         //λٶȻģʽ
} CAN_PACKET_ID;


//rmͳһݽṹ
typedef struct
{
    uint16_t ecd;
    int16_t speed_rpm;
    int16_t given_current;
    uint8_t temperate;
    int16_t last_ecd;
} motor_measure_t;

extern void CAN_CMD_CHASSIS_RESET_ID(void);

//̨revΪֽ
extern void CAN_CMD_GIMBAL(int16_t yaw, int16_t pitch, int16_t shoot, int16_t rev);
//͵̵
extern void CAN_CMD_CHASSIS(int16_t motor1, int16_t motor2, int16_t motor3, int16_t motor4);

extern void CAN_CMD_ZESC(int16_t cmd16, int16_t mode16, int32_t target_val);
//yawַָͨ뷽ʽȡԭʼ
extern const motor_measure_t *get_Yaw_Gimbal_Motor_Measure_Point(void);
//pitchַָͨ뷽ʽȡԭʼ
extern const motor_measure_t *get_Pitch_Gimbal_Motor_Measure_Point(void);
//triggerַָͨ뷽ʽȡԭʼ
extern const motor_measure_t *get_Trigger_Motor_Measure_Point(void);
//ص̵ַָͨ뷽ʽȡԭʼ,iķΧ0-3Ӧ0x201-0x204,
extern const motor_measure_t *get_Chassis_Motor_Measure_Point(uint8_t i);

extern void comm_can_transmit_eid(uint32_t id, const uint8_t *data, uint8_t len);

extern void comm_can_set_duty(uint8_t controller_id, float duty);

extern void comm_can_set_current(uint8_t controller_id, float current);

extern void comm_can_set_current_brake(uint8_t controller_id, float current);

extern void comm_can_set_rpm(uint8_t controller_id, float rpm);
extern void comm_can_set_pos(uint8_t controller_id, float pos);

extern void CAN_CMD_VESC_STD(int16_t mode, int16_t kp, int16_t kd, int16_t pos,int16_t spd,int16_t current,uint8_t controller_id);

extern void CAN_CMD_ZESC_GM(int16_t motor1, int16_t motor2, int16_t motor3, int16_t motor4);
extern void CAN_CMD_ZESC_STD(int16_t mode, int16_t kp, int16_t kd, int16_t pos,int16_t spd,int16_t current,int16_t id);

extern void CAN_CMD_ZESC_SET_DJI(void);

extern void CAN_CMD_ZESC_SET_STD(void);

extern void CAN_CMD_ZESC_SET_DJI_ID(int16_t did);

extern void CAN_CMD_ZESC_SET_STD_ID(int16_t sid);

extern void CAN_CMD_ZESC_SET_ZERO(void);

extern void CAN_CMD_ZESC_SET_CAL();

#if GIMBAL_MOTOR_6020_CAN_LOSE_SLOVE
extern void GIMBAL_lose_slove(void);
#endif

#endif
