/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       Calibrate_task.c/h
  * @brief      У׼豸ݣ̨ǣٶȼƣ
  *             ̨У׼ҪֵСԽǶȣҪУ׼Ư
  *             ٶȼƺʹֻдýӿںٶȼĿǰûбҪУ׼
  *             δʹڽ㷨С
  * @note       
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */
#ifndef CALIBRATE_TASK_H
#define CALIBRATE_TASK_H
#include "main.h"

#define imu_start_buzzer() buzzer_off() //У׼ر//buzzer_on(95, 10000) //IMUԪУ׼ķƵԼǿ

#define gimbal_start_buzzer() buzzer_off() //У׼ر//buzzer_on(31, 20000) //̨У׼ķƵԼǿ

#define cali_buzzer_off() buzzer_off() //رշ

#define cali_get_mcu_temperature() get_temprate() //ȡstm32ϵ¶ ΪIMUУ׼Ļ¶

#define cali_flash_read(address, buf, len) flash_read((address), (buf), (len))                  //flash ȡ
#define cali_flash_write(address, buf, len) flash_write_single_address((address), (buf), (len)) //flash д뺯

#define get_remote_ctrl_point_cali() get_remote_control_point() //ȡңĽṹָ
#define gyro_cali_disable_control() RC_unable()                 //У׼ʱң

//У׼
#define gyro_cali_fun(cali_scale, cali_offset, time_count) INS_cali_gyro((cali_scale), (cali_offset), (time_count))
//У׼ֵ
#define gyro_set_cali(cali_scale, cali_offset) INS_set_cali_gyro((cali_scale), (cali_offset))

#define FLASH_USER_ADDR ADDR_FLASH_SECTOR_23 //ҪдflashĿǰһ飬

#define GYRO_CONST_MAX_TEMP 45.0f //ǿƺ ¶

#define CALI_FUNC_CMD_ON 1   //У׼ʹУ׼
#define CALI_FUNC_CMD_INIT 0 //У׼flashеУ׼

#define CALIBRATE_CONTROL_TIME 1 //У׼е Ϊ1ms

#define CALI_SENSOR_HEAD_LEGHT 1 //У׼ṹıͷ Ϊcali_sensor_tǰ 꿴 cali_sensor_t С 1 һ32λ

#define SELF_ID 0              //ͷеID
#define FIRMWARE_VERSION 12345 //ͷеӲ汾 Ŀǰд
#define CALIED_FLAG 0x55       //ѾУ׼

#define CALIBRATE_END_TIME 20000 //ңУ׼ʱ20s 20sҪ²

#define RC_CALI_BUZZER_MIDDLE_TIME 10000 //У׼ʱıƵʳ̨ĸƵ20sУ׼ʱ
#define rc_cali_buzzer_middle_on() gimbal_start_buzzer()
#define RC_CALI_BUZZER_START_TIME 0 //У׼ʱıƵʳIMUĵƵУ׼ʱ20sʼʱ
#define rc_cali_buzzer_start_on() imu_start_buzzer()
#define RCCALI_BUZZER_CYCLE_TIME 400  //У׼ѡʱ20sʱ
#define RC_CALI_BUZZER_PAUSE_TIME 200 //У׼ѡʱ20sͣʱ
#define RC_CALI_VALUE_HOLE 600        //ң˻ڰ ֵж ңҡ 660 ֻҪ630 Ϊ

#define RC_CMD_LONG_TIME 2000 //ңʹУ׼ʱ䣬ڰ˵ʱ

#define GYRO_CALIBRATE_TIME 20000 //У׼ʱ 20s

//У׼豸
typedef enum
{
    CALI_HEAD,
    CALI_GIMBAL,
    CALI_GYRO,
    CALI_ACC,
    CALI_MAG,
    CALI_LIST_LENGHT,
    //add more...
} cali_id_e;

//У׼豸ǰͨflash_bufӵӦУ׼豸ַ
typedef __packed struct
{
    uint8_t name[3];
    uint8_t cali_done;
    uint8_t flash_len : 7;
    uint8_t cali_cmd : 1;
    uint32_t *flash_buf;
    bool_t (*cali_hook)(uint32_t *point, bool_t cmd);
} cali_sensor_t;

//ͷ豸У׼
typedef __packed struct
{
    uint8_t self_id;
    int8_t temperate;
    uint16_t firmware_version;
    fp32 latitude;
} head_cali_t;
//̨豸У׼
typedef struct
{
    uint16_t yaw_offset;
    uint16_t pitch_offset;
    fp32 yaw_max_angle;
    fp32 yaw_min_angle;
    fp32 pitch_max_angle;
    fp32 pitch_min_angle;
} gimbal_cali_t;
//ǣٶȼƣͨУ׼
typedef struct
{
    fp32 offset[3]; //x,y,z
    fp32 scale[3];  //x,y,z
} imu_cali_t;

//ʼԼȡflashУ׼ֵ
extern void cali_param_init(void);
//mpu6500Ƶ¶
extern int8_t get_control_temperate(void);
//У׼
extern void calibrate_task(void *pvParameters);
#endif
