/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       chassis_behaviour.c/h
  * @brief      ɵΪ
  * @note       
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */
#include "chassis_behaviour.h"
#include "chassis_task.h"
#include "arm_math.h"

#include "gimbal_behaviour.h"

/**
  * @brief          Ϊ״̬£ģʽrawʶ趨ֱֵӷ͵canϹʶ趨ֵΪ0
  * @author         RM
  * @param[in]      vx_setǰٶ 趨ֱֵӷ͵can
  * @param[in]      vy_setҵٶ 趨ֱֵӷ͵can
  * @param[in]      wz_setתٶ 趨ֱֵӷ͵can
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */
static void chassis_zero_force_control(fp32 *vx_can_set, fp32 *vy_can_set, fp32 *wz_can_set, chassis_move_t *chassis_move_rc_to_vector);

/**
  * @brief          ̲ƶΪ״̬£ģʽǲǶȣ
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      wz_setתٶȣתٶǿƵ̵ĵ̽ٶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_no_move_control(fp32 *vx_set, fp32 *vy_set, fp32 *wz_set, chassis_move_t *chassis_move_rc_to_vector);

/**
  * @brief          ̸̨Ϊ״̬£ģʽǸ̨ǶȣתٶȻݽǶȲתĽٶ
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      angle_set̨ƵԽǶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_infantry_follow_gimbal_yaw_control(fp32 *vx_set, fp32 *vy_set, fp32 *angle_set, chassis_move_t *chassis_move_rc_to_vector);

/**
  * @brief          ̸yawΪ״̬£ģʽǸ̽ǶȣתٶȻݽǶȲתĽٶ
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      angle_setõyawΧ -PIPI
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_engineer_follow_chassis_yaw_control(fp32 *vx_set, fp32 *vy_set, fp32 *angle_set, chassis_move_t *chassis_move_rc_to_vector);

/**
  * @brief          ̲ǶȵΪ״̬£ģʽǲǶȣתٶɲֱ趨
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      wz_setõתٶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */
static void chassis_no_follow_yaw_control(fp32 *vx_set, fp32 *vy_set, fp32 *wz_set, chassis_move_t *chassis_move_rc_to_vector);

/**
  * @brief          ̿Ϊ״̬£ģʽrawԭ״̬ʶ趨ֱֵӷ͵can
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      wz_setõתٶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */
static void chassis_open_set_control(fp32 *vx_set, fp32 *vy_set, fp32 *wz_set, chassis_move_t *chassis_move_rc_to_vector);

//Ϊ״̬
static chassis_behaviour_e chassis_behaviour_mode = CHASSIS_ZERO_FORCE;

void chassis_behaviour_mode_set(chassis_move_t *chassis_move_mode)
{
    if (chassis_move_mode == NULL)
    {
        return;
    }

    //ңΪģʽ
    if (switch_is_mid(chassis_move_mode->chassis_RC->rc.s[MODE_CHANNEL]))
    {
        chassis_behaviour_mode = CHASSIS_NO_FOLLOW_YAW;
    }
    else if (switch_is_down(chassis_move_mode->chassis_RC->rc.s[MODE_CHANNEL]))
    {
        chassis_behaviour_mode = CHASSIS_NO_MOVE;
    }
    else if (switch_is_up(chassis_move_mode->chassis_RC->rc.s[MODE_CHANNEL]))
    {
        chassis_behaviour_mode = CHASSIS_INFANTRY_FOLLOW_GIMBAL_YAW;
    }

    //̨ĳЩ״̬ʱ򣬵ֲ̱
    if (gimbal_cmd_to_chassis_stop())
    {
        chassis_behaviour_mode = CHASSIS_NO_MOVE;
    }

    //Ϊ״̬ѡ״̬
    if (chassis_behaviour_mode == CHASSIS_ZERO_FORCE)
    {

        chassis_move_mode->chassis_mode = CHASSIS_VECTOR_RAW; //Ϊǵõ״̬Ϊ rawԭ״̬
    }
    else if (chassis_behaviour_mode == CHASSIS_NO_MOVE)
    {

        chassis_move_mode->chassis_mode = CHASSIS_VECTOR_NO_FOLLOW_YAW; //Ϊǵ̲ƶõ״̬Ϊ ̲Ƕ ״̬
    }
    else if (chassis_behaviour_mode == CHASSIS_INFANTRY_FOLLOW_GIMBAL_YAW)
    {

        chassis_move_mode->chassis_mode = CHASSIS_VECTOR_FOLLOW_GIMBAL_YAW; //Ϊ̨õ״̬Ϊ ̸̨Ƕ ״̬
    }
    else if (chassis_behaviour_mode == CHASSIS_ENGINEER_FOLLOW_CHASSIS_YAW)
    {

        chassis_move_mode->chassis_mode = CHASSIS_VECTOR_FOLLOW_CHASSIS_YAW; //Ϊǹ̸̽Ƕȣõ״̬Ϊ ̸̽Ƕ ״̬
    }
    else if (chassis_behaviour_mode == CHASSIS_NO_FOLLOW_YAW)
    {

        chassis_move_mode->chassis_mode = CHASSIS_VECTOR_NO_FOLLOW_YAW; //Ϊǵ̲Ƕȣõ״̬Ϊ ̲Ƕ ״̬
    }
    else if (chassis_behaviour_mode == CHASSIS_OPEN)
    {

        chassis_move_mode->chassis_mode = CHASSIS_VECTOR_RAW; //Ϊǵ̿õ״̬Ϊ ԭraw ״̬
    }
}
void chassis_behaviour_control_set(fp32 *vx_set, fp32 *vy_set, fp32 *angle_set, chassis_move_t *chassis_move_rc_to_vector)
{

    if (vx_set == NULL || vy_set == NULL || angle_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }

    if (chassis_behaviour_mode == CHASSIS_ZERO_FORCE)
    {
        chassis_zero_force_control(vx_set, vy_set, angle_set, chassis_move_rc_to_vector);
    }
    else if (chassis_behaviour_mode == CHASSIS_NO_MOVE)
    {
        chassis_no_move_control(vx_set, vy_set, angle_set, chassis_move_rc_to_vector);
    }
    else if (chassis_behaviour_mode == CHASSIS_INFANTRY_FOLLOW_GIMBAL_YAW)
    {
        chassis_infantry_follow_gimbal_yaw_control(vx_set, vy_set, angle_set, chassis_move_rc_to_vector);
    }
    else if (chassis_behaviour_mode == CHASSIS_ENGINEER_FOLLOW_CHASSIS_YAW)
    {
        chassis_engineer_follow_chassis_yaw_control(vx_set, vy_set, angle_set, chassis_move_rc_to_vector);
    }
    else if (chassis_behaviour_mode == CHASSIS_NO_FOLLOW_YAW)
    {
        chassis_no_follow_yaw_control(vx_set, vy_set, angle_set, chassis_move_rc_to_vector);
    }
    else if (chassis_behaviour_mode == CHASSIS_OPEN)
    {
        chassis_open_set_control(vx_set, vy_set, angle_set, chassis_move_rc_to_vector);
    }
}
/**
  * @brief          Ϊ״̬£ģʽrawʶ趨ֱֵӷ͵canϹʶ趨ֵΪ0
  * @author         RM
  * @param[in]      vx_setǰٶ 趨ֱֵӷ͵can
  * @param[in]      vy_setҵٶ 趨ֱֵӷ͵can
  * @param[in]      wz_setתٶ 趨ֱֵӷ͵can
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_zero_force_control(fp32 *vx_can_set, fp32 *vy_can_set, fp32 *wz_can_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (vx_can_set == NULL || vy_can_set == NULL || wz_can_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }
    *vx_can_set = 0.0f;
    *vy_can_set = 0.0f;
    *wz_can_set = 0.0f;
}
/**
  * @brief          ̲ƶΪ״̬£ģʽǲǶȣ
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      wz_setתٶȣתٶǿƵ̵ĵ̽ٶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_no_move_control(fp32 *vx_set, fp32 *vy_set, fp32 *wz_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (vx_set == NULL || vy_set == NULL || wz_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }
    *vx_set = 0.0f;
    *vy_set = 0.0f;
    *wz_set = 0.0f;
}

/**
  * @brief          ̸̨Ϊ״̬£ģʽǸ̨ǶȣתٶȻݽǶȲתĽٶ
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      angle_set̨ƵԽǶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_infantry_follow_gimbal_yaw_control(fp32 *vx_set, fp32 *vy_set, fp32 *angle_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (vx_set == NULL || vy_set == NULL || angle_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }

    chassis_rc_to_control_vector(vx_set, vy_set, chassis_move_rc_to_vector);

    //ҡڽǶsinɣswing_time sinֵ
    static fp32 swing_time = 0.0f;
    //swing_time ǼĽǶ
    static fp32 swing_angle = 0.0f;
    //max_angle sinķֵ
    static fp32 max_angle = SWING_NO_MOVE_ANGLE;
    //add_time ҡڽǶȸıĿԽ
    static fp32 const add_time = PI / 250.0f;
    //ʹҡڱ־λ
    static uint8_t swing_flag = 0;

    //ңԭʼź

    //жǷҪҡ
    if (chassis_move_rc_to_vector->chassis_RC->key.v & SWING_KEY)
    {
        if (swing_flag == 0)
        {
            swing_flag = 1;
            swing_time = 0.0f;
        }
    }
    else
    {
        swing_flag = 0;
    }

    //жϼǲڿƵ˶˶СҡڽǶ
    if (chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_FRONT_KEY || chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_BACK_KEY ||
        chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_LEFT_KEY || chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_RIGHT_KEY)
    {
        max_angle = SWING_MOVE_ANGLE;
    }
    else
    {
        max_angle = SWING_NO_MOVE_ANGLE;
    }
    //sinɿƽǶ
    if (swing_flag)
    {
        swing_angle = max_angle * arm_sin_f32(swing_time);
        swing_time += add_time;
    }
    else
    {
        swing_angle = 0.0f;
    }
    //sin2pi
    if (swing_time > 2 * PI)
    {
        swing_time -= 2 * PI;
    }

    *angle_set = swing_angle;
}

/**
  * @brief          ̸yawΪ״̬£ģʽǸ̽ǶȣתٶȻݽǶȲתĽٶ
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      angle_setõyawΧ -PIPI
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_engineer_follow_chassis_yaw_control(fp32 *vx_set, fp32 *vy_set, fp32 *angle_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (vx_set == NULL || vy_set == NULL || angle_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }

    chassis_rc_to_control_vector(vx_set, vy_set, chassis_move_rc_to_vector);

    *angle_set = rad_format(chassis_move_rc_to_vector->chassis_yaw_set - CHASSIS_ANGLE_Z_RC_SEN * chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_WZ_CHANNEL]);
}

/**
  * @brief          ̲ǶȵΪ״̬£ģʽǲǶȣתٶɲֱ趨
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      wz_setõתٶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_no_follow_yaw_control(fp32 *vx_set, fp32 *vy_set, fp32 *wz_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (vx_set == NULL || vy_set == NULL || wz_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }

    chassis_rc_to_control_vector(vx_set, vy_set, chassis_move_rc_to_vector);
    *wz_set = -CHASSIS_WZ_RC_SEN * chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_WZ_CHANNEL];
}

/**
  * @brief          ̿Ϊ״̬£ģʽrawԭ״̬ʶ趨ֱֵӷ͵can
  * @author         RM
  * @param[in]      vx_setǰٶ
  * @param[in]      vy_setҵٶ
  * @param[in]      wz_setõתٶ
  * @param[in]      chassis_move_rc_to_vector
  * @retval         ؿ
  */

static void chassis_open_set_control(fp32 *vx_set, fp32 *vy_set, fp32 *wz_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (vx_set == NULL || vy_set == NULL || wz_set == NULL || chassis_move_rc_to_vector == NULL)
    {
        return;
    }

    *vx_set = chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_X_CHANNEL] * CHASSIS_OPEN_RC_SCALE;
    *vy_set = -chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_Y_CHANNEL] * CHASSIS_OPEN_RC_SCALE;
    *wz_set = -chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_WZ_CHANNEL] * CHASSIS_OPEN_RC_SCALE;
    return;
}
