/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       chassis.c/h
  * @brief      ɵ̿
  * @note       
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */
#include "chassis_task.h"

#include "rc.h"

#include "FreeRTOSConfig.h"
#include "FreeRTOS.h"
#include "task.h"

#include "arm_math.h"

#include "CAN_Receive.h"
#include "Detect_Task.h"
#include "pid.h"
#include "led.h"

#include "Remote_Control.h"
#include "INS_Task.h"

#include "chassis_behaviour.h"
#include "stm32f4xx.h"

#define rc_deadline_limit(input, output, dealine)        \
    {                                                    \
        if ((input) > (dealine) || (input) < -(dealine)) \
        {                                                \
            (output) = (input);                          \
        }                                                \
        else                                             \
        {                                                \
            (output) = 0;                                \
        }                                                \
    }

//˶
static chassis_move_t chassis_move;

//̳ʼҪpidʼ
static void chassis_init(chassis_move_t *chassis_move_init);
//״̬ѡͨңĿ
static void chassis_set_mode(chassis_move_t *chassis_move_mode);
//ݸ
static void chassis_feedback_update(chassis_move_t *chassis_move_update);
//״̬ıĸıstatic
void chassis_mode_change_control_transit(chassis_move_t *chassis_move_transit);
//øң
static void chassis_set_contorl(chassis_move_t *chassis_move_control);
//PIDԼ˶ֽ
static void chassis_control_loop(chassis_move_t *chassis_move_control_loop);

#if INCLUDE_uxTaskGetStackHighWaterMark
uint32_t chassis_high_water;
#endif

//
#define ZESC_ID  0x206
#define CMESC_ID  0X68//16
int32_t temp_cnt=0;
int32_t temp_sign=1;
uint8_t  KEY_STATE=0;
uint8_t key_state_machine=0;
uint32_t key_down_cnt=0;
uint8_t temp_step=0;
void chassis_task(void *pvParameters)
{
    //һʱ
    vTaskDelay(CHASSIS_TASK_INIT_TIME);
    //̳ʼ
    chassis_init(&chassis_move);
    //жϵ̵Ƿ
//	  CAN_CMD_ZESC(CAN_PACKET_SET_ORIGIN_HERE,0,0);//Уʼλ
//	  vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	  //CAN_CMD_ZESC(CAN_PACKET_SET_ENC_OFFSET,0,1200);//ñƫ
//	  //vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	  CAN_CMD_ZESC(CAN_PACKET_SET_ORIGIN_HERE,0,0);//Уʼλ
//	  vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	  CAN_CMD_ZESC(CAN_PACKET_SET_ADRC_GAIN,0,250);//ADRC 100-500Ӧ0.4-2.0
//	  vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	  CAN_CMD_ZESC(CAN_PACKET_SET_ORIGIN_HERE,1,0);//
//	  vTaskDelay(CHASSIS_CONTROL_TIME_MS);
////	  CAN_CMD_ZESC(CAN_PACKET_SET_ELEC_ZERO,0,2000);//ǶУ׼
////	  vTaskDelay(CHASSIS_TASK_INIT_TIME);
//	  CAN_CMD_ZESC(CAN_PACKET_SET_ORIGIN_HERE,1,0);//
//	  vTaskDelay(CHASSIS_TASK_INIT_TIME);
	
//	      CAN_CMD_ZESC_SET_STD();
//	      vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	      CAN_CMD_ZESC_SET_STD();
//				vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	      CAN_CMD_ZESC_SET_STD_ID(0x206);//set_std_id
//				vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//				CAN_CMD_ZESC_SET_STD();
//				vTaskDelay(CHASSIS_CONTROL_TIME_MS);

//				CAN_CMD_ZESC_SET_DJI();
//				vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//	      CAN_CMD_ZESC_SET_DJI_ID(0x208);//set_std_id
//				vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//				CAN_CMD_ZESC_SET_DJI();
//				vTaskDelay(CHASSIS_CONTROL_TIME_MS);
//				
	  //comm_can_set_pos(CMESC_ID,180.0f);//CMESC,ID
    //while (toe_is_error(ChassisMotor1TOE) || toe_is_error(ChassisMotor2TOE) || toe_is_error(ChassisMotor3TOE) || toe_is_error(ChassisMotor4TOE) || toe_is_error(DBUSTOE))
	//while(1)
    {
			  
			//comm_can_set_pos(CMESC_ID,125.0f);//CMESC,ID
			//comm_can_set_rpm(CMESC_ID,1400.0f);//CMESCת
			//comm_can_set_current(CMESC_ID,3.0f);//CMESC
			//comm_can_set_duty(CMESC_ID,20.0f);//CMESCռձ
        
			KEY_STATE=GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_2);
			if(KEY_STATE && key_state_machine == 0)key_state_machine=1;
			if(!KEY_STATE && key_state_machine==1)key_state_machine=2;
			if(key_state_machine==1 && KEY_STATE)key_down_cnt++;else if(key_state_machine != 2)key_down_cnt=0;
			if(key_state_machine==1 && key_down_cnt>250 && KEY_STATE){temp_cnt=temp_cnt+4*temp_sign;}

			//if(!KEY_STATE && key_state_machine==3)key_state_machine=0;
			if(key_state_machine==2 && !KEY_STATE && key_down_cnt<250 && key_down_cnt>50){key_state_machine = 0;temp_step=(temp_step+1)%4;temp_cnt= 1600*temp_step;}
			else if(key_state_machine==2)key_state_machine=0;
			
			if(temp_cnt>6400 && temp_sign==1){temp_sign=-1;}
			else if(temp_cnt<100 && temp_sign==-1){temp_sign=1;}
			//temp_cnt+=temp_sign;
			//comm_can_set_pos(CMESC_ID,0.1f*((temp_cnt)%3600));
			//CAN_CMD_CMESC_STD(0x00,0x1ff,0x1ff,(temp_cnt*5),1588,512,CMESC_ID);//(int16_t mode, int16_t kp, int16_t kd, int16_t pos,int16_t spd,int16_t current,int16_t id)//std mode cmd
			if(KEY_STATE)
				{
			led_green_on();
					//comm_can_set_pos(CMESC_ID,temp_cnt*0.05f);
					//CAN_CMD_CMESC_STD(0x00,0x1ff,0x1ff,(temp_cnt*5),1588,512,CMESC_ID);//(int16_t mode, int16_t kp, int16_t kd, int16_t pos,int16_t spd,int16_t current,int16_t id)//std mode cmd
					
					
					
					
					//CAN_CMD_ZESC_SET_CAL();
					
					//CAN_CMD_ZESC_GM(1500,1200,800,500);//DJI_MODE_CURRENT_CONTROL
					//CAN_CMD_ZESC_SET_ZERO();//calib_zero_point
					//CAN_CMD_ZESC_SET_STD_ID(0x206);//set_std_id
					//CAN_CMD_ZESC_SET_DJI_ID(0x205);//set dji id
					//CAN_CMD_ZESC_SET_STD();//go to std mode
					//CAN_CMD_ZESC_SET_DJI();//go to dji mode
					CAN_CMD_ZESC_STD(0x00,0x12f,0x12f,temp_cnt*5,2080,0x0ff,0x206);//(int16_t mode, int16_t kp, int16_t kd, int16_t pos,int16_t spd,int16_t current,int16_t id)//std mode cmd
					
					
					
					
					
			//CAN_CMD_ZESC(CAN_PACKET_SET_POS,0,(((temp_cnt)%7200)-3600));//DEMOʾ
			//CAN_CMD_ZESC(CAN_PACKET_SET_ORIGIN_HERE,1,0);//ԭλ
      //CAN_CMD_ZESC(CAN_PACKET_SET_POS,0,0);//صԭ
			//CAN_CMD_ZESC(CAN_PACKET_SET_CURRENT,0,5000);// -10000 - +10000 Ӧ-MAX - +MAX
			//CAN_CMD_ZESC(CAN_PACKET_SET_DUTY,0,2000);//ռձ -10000 - +10000 Ӧ-MAX - +MAX
			//CAN_CMD_ZESC(CAN_PACKET_SET_RPM,0,5000);//ת -5000 - +5000 Ӧ-400 - +400
			
			//CAN_CMD_ZESC(CAN_PACKET_SET_ORIGIN_HERE,0,0);//Уʼλ
			//CAN_CMD_ZESC(CAN_PACKET_SET_ADRC_GAIN,0,250);//ADRC 100-500Ӧ0.4-2.0
			  }
				else led_green_off();
			
			vTaskDelay(CHASSIS_CONTROL_TIME_MS);
    }

    while (1)
    {
        //ң״̬
        chassis_set_mode(&chassis_move);
        //ң״̬лݱ
        chassis_mode_change_control_transit(&chassis_move);
        //ݸ
        chassis_feedback_update(&chassis_move);
        //̿
        chassis_set_contorl(&chassis_move);
        //̿PID
        chassis_control_loop(&chassis_move);
			if(chassis_move.chassis_RC->rc.s[1]==0x01)
			{
//				 CAN_CMD_CMESC_STD((chassis_move.chassis_RC->rc.s[0]-1)&0x03,0x0ff,0x0ff,(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*18+16383),(int16_t)(chassis_move.chassis_RC->rc.ch[3]*4),(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*4),CMESC_ID);
			  if(chassis_move.chassis_RC->rc.s[0]==0x01)comm_can_set_current(CMESC_ID,chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*0.06f);
			  else if(chassis_move.chassis_RC->rc.s[0]==0x03)comm_can_set_rpm(CMESC_ID,chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*30.0f);
			  else comm_can_set_pos(CMESC_ID,chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*0.15f+180.0f);
      }else if(chassis_move.chassis_RC->rc.s[1]==0x03)
			{
       CAN_CMD_ZESC_STD((chassis_move.chassis_RC->rc.s[0]-1)&0x03,0x1ff,0x1ff,(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*32+16383),(int16_t)(chassis_move.chassis_RC->rc.ch[3]*4),(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*4),ZESC_ID);
			}
			else if(chassis_move.chassis_RC->rc.s[1]==0x02)CAN_CMD_ZESC_SET_CAL();
			
			// CAN_CMD_CMESC_STD((chassis_move.chassis_RC->rc.s[0]-1)&0x03,0x1ff,0x1ff,(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*10+16383),(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*4),(int16_t)(chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*4),CMESC_ID);

		
			 //CAN_CMD_CMESC_STD(0x00,0x1ff,0x1ff,8192,1588,512,CMESC_ID);//comm_can_set_current(CMESC_ID,chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*0.06f);
			    //comm_can_set_pos(CMESC_ID,chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*0.2f+180.0f);
			    //comm_can_set_rpm(CMESC_ID,chassis_move.chassis_RC->rc.ch[CHASSIS_X_CHANNEL]*40.0f);

//        if (!(toe_is_error(ChassisMotor1TOE) || toe_is_error(ChassisMotor2TOE) || toe_is_error(ChassisMotor3TOE) || toe_is_error(ChassisMotor4TOE)))
//        {
//            //ңߵʱΪrelax״̵ָ̬Ϊ㣬Ϊ˱֤һΪ㣬ʶgive_currentķ
//            if (toe_is_error(DBUSTOE))
//            {
//                CAN_CMD_CHASSIS(0, 0, 0, 0);
//            }
//            else
//            {
//                CAN_CMD_CHASSIS(chassis_move.motor_chassis[0].give_current, chassis_move.motor_chassis[1].give_current,
//                                chassis_move.motor_chassis[2].give_current, chassis_move.motor_chassis[3].give_current);
//            }
//        }
        //ϵͳʱ
        vTaskDelay(CHASSIS_CONTROL_TIME_MS);

#if INCLUDE_uxTaskGetStackHighWaterMark
        chassis_high_water = uxTaskGetStackHighWaterMark(NULL);
#endif
    }
}

static void chassis_init(chassis_move_t *chassis_move_init)
{
    if (chassis_move_init == NULL)
    {
        return;
    }

    //ٶȻpidֵ
    const static fp32 motor_speed_pid[3] = {M3505_MOTOR_SPEED_PID_KP, M3505_MOTOR_SPEED_PID_KI, M3505_MOTOR_SPEED_PID_KD};
    //תpidֵ
    const static fp32 chassis_yaw_pid[3] = {CHASSIS_FOLLOW_GIMBAL_PID_KP, CHASSIS_FOLLOW_GIMBAL_PID_KI, CHASSIS_FOLLOW_GIMBAL_PID_KD};
    const static fp32 chassis_x_order_filter[1] = {CHASSIS_ACCEL_X_NUM};
    const static fp32 chassis_y_order_filter[1] = {CHASSIS_ACCEL_Y_NUM};
    uint8_t i;

    //̿״̬Ϊֹͣ
    chassis_move_init->chassis_mode = CHASSIS_VECTOR_RAW;
    //ȡңָ
    chassis_move_init->chassis_RC = get_remote_control_point();
    //ȡָ̬
    chassis_move_init->chassis_INS_angle = get_INS_angle_point();
    //ȡָ̨
    chassis_move_init->chassis_yaw_motor = get_yaw_motor_point();
    chassis_move_init->chassis_pitch_motor = get_pitch_motor_point();
    //ʼPID ˶
    for (i = 0; i < 4; i++)
    {
        chassis_move_init->motor_chassis[i].chassis_motor_measure = get_Chassis_Motor_Measure_Point(i);
        PID_Init(&chassis_move_init->motor_speed_pid[i], PID_POSITION, motor_speed_pid, M3505_MOTOR_SPEED_PID_MAX_OUT, M3505_MOTOR_SPEED_PID_MAX_IOUT);
    }
    //ʼתPID
    PID_Init(&chassis_move_init->chassis_angle_pid, PID_POSITION, chassis_yaw_pid, CHASSIS_FOLLOW_GIMBAL_PID_MAX_OUT, CHASSIS_FOLLOW_GIMBAL_PID_MAX_IOUT);
    //һ˲б
    first_order_filter_init(&chassis_move_init->chassis_cmd_slow_set_vx, CHASSIS_CONTROL_TIME, chassis_x_order_filter);
    first_order_filter_init(&chassis_move_init->chassis_cmd_slow_set_vy, CHASSIS_CONTROL_TIME, chassis_y_order_filter);

    // Сٶ
    chassis_move_init->vx_max_speed = NORMAL_MAX_CHASSIS_SPEED_X;
    chassis_move_init->vx_min_speed = -NORMAL_MAX_CHASSIS_SPEED_X;

    chassis_move_init->vy_max_speed = NORMAL_MAX_CHASSIS_SPEED_Y;
    chassis_move_init->vy_min_speed = -NORMAL_MAX_CHASSIS_SPEED_Y;

    //һ
    chassis_feedback_update(chassis_move_init);
}

static void chassis_set_mode(chassis_move_t *chassis_move_mode)
{
    if (chassis_move_mode == NULL)
    {
        return;
    }

    chassis_behaviour_mode_set(chassis_move_mode);
}

static void chassis_mode_change_control_transit(chassis_move_t *chassis_move_transit)
{
    if (chassis_move_transit == NULL)
    {
        return;
    }

    if (chassis_move_transit->last_chassis_mode == chassis_move_transit->chassis_mode)
    {
        return;
    }

    //̨ģʽ
    if ((chassis_move_transit->last_chassis_mode != CHASSIS_VECTOR_FOLLOW_GIMBAL_YAW) && chassis_move_transit->chassis_mode == CHASSIS_VECTOR_FOLLOW_GIMBAL_YAW)
    {
        chassis_move_transit->chassis_relative_angle_set = 0.0f;
    }
    //̽Ƕģʽ
    else if ((chassis_move_transit->last_chassis_mode != CHASSIS_VECTOR_FOLLOW_CHASSIS_YAW) && chassis_move_transit->chassis_mode == CHASSIS_VECTOR_FOLLOW_CHASSIS_YAW)
    {
        chassis_move_transit->chassis_yaw_set = chassis_move_transit->chassis_yaw;
    }
    //벻̨ģʽ
    else if ((chassis_move_transit->last_chassis_mode != CHASSIS_VECTOR_NO_FOLLOW_YAW) && chassis_move_transit->chassis_mode == CHASSIS_VECTOR_NO_FOLLOW_YAW)
    {
        chassis_move_transit->chassis_yaw_set = chassis_move_transit->chassis_yaw;
    }

    chassis_move_transit->last_chassis_mode = chassis_move_transit->chassis_mode;
}

static void chassis_feedback_update(chassis_move_t *chassis_move_update)
{
    if (chassis_move_update == NULL)
    {
        return;
    }

    uint8_t i = 0;
    for (i = 0; i < 4; i++)
    {
        //µٶȣٶٶȵPID΢
        chassis_move_update->motor_chassis[i].speed = CHASSIS_MOTOR_RPM_TO_VECTOR_SEN * chassis_move_update->motor_chassis[i].chassis_motor_measure->speed_rpm;
        chassis_move_update->motor_chassis[i].accel = chassis_move_update->motor_speed_pid[i].Dbuf[0] * CHASSIS_CONTROL_FREQUENCE;
    }

    //µǰٶ x ƽٶyתٶwzϵΪϵ
    chassis_move_update->vx = (-chassis_move_update->motor_chassis[0].speed + chassis_move_update->motor_chassis[1].speed + chassis_move_update->motor_chassis[2].speed - chassis_move_update->motor_chassis[3].speed) * MOTOR_SPEED_TO_CHASSIS_SPEED_VX;
    chassis_move_update->vy = (-chassis_move_update->motor_chassis[0].speed - chassis_move_update->motor_chassis[1].speed + chassis_move_update->motor_chassis[2].speed + chassis_move_update->motor_chassis[3].speed) * MOTOR_SPEED_TO_CHASSIS_SPEED_VY;
    chassis_move_update->wz = (-chassis_move_update->motor_chassis[0].speed - chassis_move_update->motor_chassis[1].speed - chassis_move_update->motor_chassis[2].speed - chassis_move_update->motor_chassis[3].speed) * MOTOR_SPEED_TO_CHASSIS_SPEED_WZ / MOTOR_DISTANCE_TO_CENTER;

    //̬Ƕ, ⲿִ
    chassis_move_update->chassis_yaw = rad_format(*(chassis_move_update->chassis_INS_angle + INS_YAW_ADDRESS_OFFSET) - chassis_move_update->chassis_yaw_motor->relative_angle);
    chassis_move_update->chassis_pitch = rad_format(*(chassis_move_update->chassis_INS_angle + INS_PITCH_ADDRESS_OFFSET) - chassis_move_update->chassis_pitch_motor->relative_angle);
    chassis_move_update->chassis_roll = *(chassis_move_update->chassis_INS_angle + INS_ROLL_ADDRESS_OFFSET);
}

//ңݴɵ̵ǰvxٶȣvyٶ
void chassis_rc_to_control_vector(fp32 *vx_set, fp32 *vy_set, chassis_move_t *chassis_move_rc_to_vector)
{
    if (chassis_move_rc_to_vector == NULL || vx_set == NULL || vy_set == NULL)
    {
        return;
    }
    //ңԭʼֵͨ
    int16_t vx_channel, vy_channel;
    fp32 vx_set_channel, vy_set_channel;
    //ƣΪңܴڲ ҡм䣬ֵΪ0
    rc_deadline_limit(chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_X_CHANNEL], vx_channel, CHASSIS_RC_DEADLINE);
    rc_deadline_limit(chassis_move_rc_to_vector->chassis_RC->rc.ch[CHASSIS_Y_CHANNEL], vy_channel, CHASSIS_RC_DEADLINE);

    vx_set_channel = vx_channel * CHASSIS_VX_RC_SEN;
    vy_set_channel = vy_channel * -CHASSIS_VY_RC_SEN;

    if (chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_FRONT_KEY)
    {
        vx_set_channel = chassis_move_rc_to_vector->vx_max_speed;
    }
    else if (chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_BACK_KEY)
    {
        vx_set_channel = chassis_move_rc_to_vector->vx_min_speed;
    }

    if (chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_LEFT_KEY)
    {
        vy_set_channel = chassis_move_rc_to_vector->vy_max_speed;
    }
    else if (chassis_move_rc_to_vector->chassis_RC->key.v & CHASSIS_RIGHT_KEY)
    {
        vy_set_channel = chassis_move_rc_to_vector->vy_min_speed;
    }

    //һ׵ͨ˲бΪٶ
    first_order_filter_cali(&chassis_move_rc_to_vector->chassis_cmd_slow_set_vx, vx_set_channel);
    first_order_filter_cali(&chassis_move_rc_to_vector->chassis_cmd_slow_set_vy, vy_set_channel);

    //ֹͣźţҪ٣ֱӼٵ
    if (vx_set_channel < CHASSIS_RC_DEADLINE * CHASSIS_VX_RC_SEN && vx_set_channel > -CHASSIS_RC_DEADLINE * CHASSIS_VX_RC_SEN)
    {
        chassis_move_rc_to_vector->chassis_cmd_slow_set_vx.out = 0.0f;
    }

    if (vy_set_channel < CHASSIS_RC_DEADLINE * CHASSIS_VY_RC_SEN && vy_set_channel > -CHASSIS_RC_DEADLINE * CHASSIS_VY_RC_SEN)
    {
        chassis_move_rc_to_vector->chassis_cmd_slow_set_vy.out = 0.0f;
    }

    *vx_set = chassis_move_rc_to_vector->chassis_cmd_slow_set_vx.out;
    *vy_set = chassis_move_rc_to_vector->chassis_cmd_slow_set_vy.out;
}

//ң
static void chassis_set_contorl(chassis_move_t *chassis_move_control)
{

    if (chassis_move_control == NULL)
    {
        return;
    }

    //ٶ
    fp32 vx_set = 0.0f, vy_set = 0.0f, angle_set = 0.0f;
    chassis_behaviour_control_set(&vx_set, &vy_set, &angle_set, chassis_move_control);

    //̨ģʽ
    if (chassis_move_control->chassis_mode == CHASSIS_VECTOR_FOLLOW_GIMBAL_YAW)
    {
        fp32 sin_yaw = 0.0f, cos_yaw = 0.0f;
        //תƵٶȷ򣬱֤ǰ̨˶ƽ
        sin_yaw = arm_sin_f32(-chassis_move_control->chassis_yaw_motor->relative_angle);
        cos_yaw = arm_cos_f32(-chassis_move_control->chassis_yaw_motor->relative_angle);
        chassis_move_control->vx_set = cos_yaw * vx_set + sin_yaw * vy_set;
        chassis_move_control->vy_set = -sin_yaw * vx_set + cos_yaw * vy_set;
        //ÿ̨Ƕ
        chassis_move_control->chassis_relative_angle_set = rad_format(angle_set);
        //תPIDٶ
        chassis_move_control->wz_set = -PID_Calc(&chassis_move_control->chassis_angle_pid, chassis_move_control->chassis_yaw_motor->relative_angle, chassis_move_control->chassis_relative_angle_set);
        //ٶ޷
        chassis_move_control->vx_set = fp32_constrain(chassis_move_control->vx_set, chassis_move_control->vx_min_speed, chassis_move_control->vx_max_speed);
        chassis_move_control->vy_set = fp32_constrain(chassis_move_control->vy_set, chassis_move_control->vy_min_speed, chassis_move_control->vy_max_speed);
    }
    else if (chassis_move_control->chassis_mode == CHASSIS_VECTOR_FOLLOW_CHASSIS_YAW)
    {
        fp32 delat_angle = 0.0f;
        //̨
        //õ̿ƵĽǶ
        chassis_move_control->chassis_yaw_set = rad_format(angle_set);
        delat_angle = rad_format(chassis_move_control->chassis_yaw_set - chassis_move_control->chassis_yaw);
        //תĽٶ
        chassis_move_control->wz_set = PID_Calc(&chassis_move_control->chassis_angle_pid, 0.0f, delat_angle);
        //õ˶ٶ
        chassis_move_control->vx_set = fp32_constrain(vx_set, chassis_move_control->vx_min_speed, chassis_move_control->vx_max_speed);
        chassis_move_control->vy_set = fp32_constrain(vy_set, chassis_move_control->vy_min_speed, chassis_move_control->vy_max_speed);
    }
    else if (chassis_move_control->chassis_mode == CHASSIS_VECTOR_NO_FOLLOW_YAW)
    {

        //̨
        //ģʽ£ǶõΪ ٶ
        fp32 chassis_wz = angle_set;
        chassis_move_control->wz_set = chassis_wz;
        chassis_move_control->vx_set = fp32_constrain(vx_set, chassis_move_control->vx_min_speed, chassis_move_control->vx_max_speed);
        chassis_move_control->vy_set = fp32_constrain(vy_set, chassis_move_control->vy_min_speed, chassis_move_control->vy_max_speed);
    }
    else if (chassis_move_control->chassis_mode == CHASSIS_VECTOR_RAW)
    {
        chassis_move_control->vx_set = vx_set;
        chassis_move_control->vy_set = vy_set;
        chassis_move_control->wz_set = angle_set;
        chassis_move_control->chassis_cmd_slow_set_vx.out = 0.0f;
        chassis_move_control->chassis_cmd_slow_set_vy.out = 0.0f;
    }
}
static void chassis_vector_to_mecanum_wheel_speed(const fp32 vx_set, const fp32 vy_set, const fp32 wz_set, fp32 wheel_speed[4])
{
    //תʱ ̨ǰǰ 0 1 תٶȱ  2,3 תٶȱ
    wheel_speed[0] = -vx_set - vy_set + (CHASSIS_WZ_SET_SCALE - 1.0f) * MOTOR_DISTANCE_TO_CENTER * wz_set;
    wheel_speed[1] = vx_set - vy_set + (CHASSIS_WZ_SET_SCALE - 1.0f) * MOTOR_DISTANCE_TO_CENTER * wz_set;
    wheel_speed[2] = vx_set + vy_set + (-CHASSIS_WZ_SET_SCALE - 1.0f) * MOTOR_DISTANCE_TO_CENTER * wz_set;
    wheel_speed[3] = -vx_set + vy_set + (-CHASSIS_WZ_SET_SCALE - 1.0f) * MOTOR_DISTANCE_TO_CENTER * wz_set;
}

static void chassis_control_loop(chassis_move_t *chassis_move_control_loop)
{
    fp32 max_vector = 0.0f, vector_rate = 0.0f;
    fp32 temp = 0.0f;
    fp32 wheel_speed[4] = {0.0f, 0.0f, 0.0f, 0.0f};
    uint8_t i = 0;
    //˶ֽ
    chassis_vector_to_mecanum_wheel_speed(chassis_move_control_loop->vx_set,
                                          chassis_move_control_loop->vy_set, chassis_move_control_loop->wz_set, wheel_speed);

    if (chassis_move_control_loop->chassis_mode == CHASSIS_VECTOR_RAW)
    {
        //ֵֵ
        for (i = 0; i < 4; i++)
        {
            chassis_move_control_loop->motor_chassis[i].give_current = (int16_t)(wheel_speed[i]);
        }
        //rawֱӷ
        return;
    }

    //ӿٶȣٶ
    for (i = 0; i < 4; i++)
    {
        chassis_move_control_loop->motor_chassis[i].speed_set = wheel_speed[i];
        temp = fabs(chassis_move_control_loop->motor_chassis[i].speed_set);
        if (max_vector < temp)
        {
            max_vector = temp;
        }
    }

    if (max_vector > MAX_WHEEL_SPEED)
    {
        vector_rate = MAX_WHEEL_SPEED / max_vector;
        for (i = 0; i < 4; i++)
        {
            chassis_move_control_loop->motor_chassis[i].speed_set *= vector_rate;
        }
    }

    //pid

    for (i = 0; i < 4; i++)
    {
        PID_Calc(&chassis_move_control_loop->motor_speed_pid[i], chassis_move_control_loop->motor_chassis[i].speed, chassis_move_control_loop->motor_chassis[i].speed_set);
    }

    //ֵֵ
    for (i = 0; i < 4; i++)
    {
        chassis_move_control_loop->motor_chassis[i].give_current = (int16_t)(chassis_move_control_loop->motor_speed_pid[i].out);
    }
}
