/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       chassis.c/h
  * @brief      ɵ̿
  * @note       
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */
#ifndef CHASSISTASK_H
#define CHASSISTASK_H
#include "main.h"
#include "CAN_Receive.h"
#include "Gimbal_Task.h"
#include "pid.h"
#include "Remote_Control.h"
#include "user_lib.h"
//ʼһʱ
#define CHASSIS_TASK_INIT_TIME 2500

//ǰңͨ
#define CHASSIS_X_CHANNEL 1
//ҵңͨ
#define CHASSIS_Y_CHANNEL 0
//ģʽ£ͨңת
#define CHASSIS_WZ_CHANNEL 2

//ѡ״̬ ͨ
#define MODE_CHANNEL 0
//ңǰҡˣmax 660תɳǰٶȣm/sı
#define CHASSIS_VX_RC_SEN 0.006f
//ңҡˣmax 660תɳٶȣm/sı
#define CHASSIS_VY_RC_SEN 0.005f
//yawģʽ£ңyawңˣmax 660ӵǶȵı
#define CHASSIS_ANGLE_Z_RC_SEN 0.000002f
//̨ʱ ңyawңˣmax 660תɳתٶȵı
#define CHASSIS_WZ_RC_SEN 0.01f

#define CHASSIS_ACCEL_X_NUM 0.1666666667f
#define CHASSIS_ACCEL_Y_NUM 0.3333333333f

#define CHASSIS_RC_DEADLINE 10

#define MOTOR_SPEED_TO_CHASSIS_SPEED_VX 0.25f
#define MOTOR_SPEED_TO_CHASSIS_SPEED_VY 0.25f
#define MOTOR_SPEED_TO_CHASSIS_SPEED_WZ 0.25f

#define MOTOR_DISTANCE_TO_CENTER 0.2f

//Ƽ 2ms
#define CHASSIS_CONTROL_TIME_MS 1
//Ƽ 0.002s
#define CHASSIS_CONTROL_TIME 0.002
//Ƶʣδʹ
#define CHASSIS_CONTROL_FREQUENCE 500.0f
//3508can͵ֵ
#define MAX_MOTOR_CAN_CURRENT 16000.0f
//ҡڰ
#define SWING_KEY KEY_PRESSED_OFFSET_CTRL
//ǰҿư
#define CHASSIS_FRONT_KEY KEY_PRESSED_OFFSET_W
#define CHASSIS_BACK_KEY KEY_PRESSED_OFFSET_S
#define CHASSIS_LEFT_KEY KEY_PRESSED_OFFSET_A
#define CHASSIS_RIGHT_KEY KEY_PRESSED_OFFSET_D

//m3508תɵٶ(m/s)ı ΪܻҪ
#define M3508_MOTOR_RPM_TO_VECTOR 0.000415809748903494517209f
#define CHASSIS_MOTOR_RPM_TO_VECTOR_SEN M3508_MOTOR_RPM_TO_VECTOR

//̵ٶ
#define MAX_WHEEL_SPEED 4.0f
//˶ǰٶ
#define NORMAL_MAX_CHASSIS_SPEED_X 3.0f
//˶ƽٶ
#define NORMAL_MAX_CHASSIS_SPEED_Y 2.9f
//תٶȣǰֲͬ趨ٶȵıȨ 0ΪڼģҪ
#define CHASSIS_WZ_SET_SCALE 0.1f

//ҡԭزҡǶ(rad)
#define SWING_NO_MOVE_ANGLE 0.7f
//ҡڹ̵˶Ƕ(rad)
#define SWING_MOVE_ANGLE 0.31415926535897932384626433832795f

//̵ٶȻPID
#define M3505_MOTOR_SPEED_PID_KP 15000.0f
#define M3505_MOTOR_SPEED_PID_KI 10.0f
#define M3505_MOTOR_SPEED_PID_KD 0.0f
#define M3505_MOTOR_SPEED_PID_MAX_OUT MAX_MOTOR_CAN_CURRENT
#define M3505_MOTOR_SPEED_PID_MAX_IOUT 2000.0f

//תPID
#define CHASSIS_FOLLOW_GIMBAL_PID_KP 40.0f
#define CHASSIS_FOLLOW_GIMBAL_PID_KI 0.0f
#define CHASSIS_FOLLOW_GIMBAL_PID_KD 0.0f
#define CHASSIS_FOLLOW_GIMBAL_PID_MAX_OUT 6.0f
#define CHASSIS_FOLLOW_GIMBAL_PID_MAX_IOUT 0.2f

typedef enum
{
  CHASSIS_VECTOR_FOLLOW_GIMBAL_YAW,
  CHASSIS_VECTOR_FOLLOW_CHASSIS_YAW,
  CHASSIS_VECTOR_NO_FOLLOW_YAW,
  CHASSIS_VECTOR_RAW,

  //  CHASSIS_AUTO,
  //  CHASSIS_FOLLOW_YAW,
  //  CHASSIS_ENCODER,
  //  CHASSIS_NO_ACTION,
  //  CHASSIS_RELAX,
} chassis_mode_e;

typedef struct
{
  const motor_measure_t *chassis_motor_measure;
  fp32 accel;
  fp32 speed;
  fp32 speed_set;
  int16_t give_current;
} Chassis_Motor_t;

typedef struct
{
  const RC_ctrl_t *chassis_RC;               //ʹõңָ
  const Gimbal_Motor_t *chassis_yaw_motor;   //ʹõyaw̨ԽǶ̵ŷ
  const Gimbal_Motor_t *chassis_pitch_motor; //ʹõpitch̨ԽǶ̵ŷ
  const fp32 *chassis_INS_angle;             //ȡǽŷָ
  chassis_mode_e chassis_mode;               //̿״̬
  chassis_mode_e last_chassis_mode;          //ϴο״̬
  Chassis_Motor_t motor_chassis[4];          //̵
  PidTypeDef motor_speed_pid[4];             //̵ٶpid
  PidTypeDef chassis_angle_pid;              //̸Ƕpid

  first_order_filter_type_t chassis_cmd_slow_set_vx;
  first_order_filter_type_t chassis_cmd_slow_set_vy;

  fp32 vx;                         //ٶ ǰ ǰΪλ m/s
  fp32 vy;                         //ٶ ҷ Ϊ  λ m/s
  fp32 wz;                         //תٶȣʱΪ λ rad/s
  fp32 vx_set;                     //趨ٶ ǰ ǰΪλ m/s
  fp32 vy_set;                     //趨ٶ ҷ Ϊλ m/s
  fp32 wz_set;                     //趨תٶȣʱΪ λ rad/s
  fp32 chassis_relative_angle;     //̨ԽǶȣλ rad/s
  fp32 chassis_relative_angle_set; //̨ƽǶ
  fp32 chassis_yaw_set;

  fp32 vx_max_speed;  //ǰٶ λm/s
  fp32 vx_min_speed;  //ǰСٶ λm/s
  fp32 vy_max_speed;  //ҷٶ λm/s
  fp32 vy_min_speed;  //ҷСٶ λm/s
  fp32 chassis_yaw;   //Ą̊́ӵyawǶ
  fp32 chassis_pitch; //Ą̊́ӵpitchǶ
  fp32 chassis_roll;  //Ą̊́ӵrollǶ

} chassis_move_t;

extern void chassis_task(void *pvParameters);
extern void chassis_rc_to_control_vector(fp32 *vx_set, fp32 *vy_set, chassis_move_t *chassis_move_rc_to_vector);

#endif
