/**
  ****************************(C) COPYRIGHT 2016 DJI****************************
  * @file       detect_task.c/h
  * @brief      豸жͨfreeRTOSδʱΪϵͳʱ䣬豸ȡݺ
  *             DetectHook¼Ӧ豸ʱ䣬ڸͨжϼ¼ʱϵͳ
  *             ʱ֮жϵߣͬʱߵȼͨLEDķʽı䣬
  *             ˸ˮʾSBUBң̨ϵĵ4̵Ҳͨ
  *             ˸ʾ롣
  * @history
  *  Version    Date            Author          Modification
  *  V1.0.0     Dec-26-2018     RM              1. 
  *
  @verbatim
  ==============================================================================

  ==============================================================================
  @endverbatim
  ****************************(C) COPYRIGHT 2016 DJI****************************
  */

#include "Detect_Task.h"

#include "led.h"

#include "CAN_Receive.h"
#include "Remote_Control.h"

#include "FreeRTOSConfig.h"
#include "FreeRTOS.h"
#include "task.h"

//л
#define DETECT_LED_R_TOGGLE() led_red_toggle()
#define DETECT_LED_R_ON() led_red_on()
#define DETECT_LED_R_OFF() led_red_off()
//ˮ
#define DETECT_FLOW_LED_ON(i) flow_led_on(i)
#define DETECT_FLOW_LED_OFF(i) flow_led_off(i)

#define DETECT_TASK_INIT_TIME 57
#define DETECT_CONTROL_TIME 10
//ʼб
static void DetectInit(uint32_t time);
//ʾȼߵĴ󣬴ĲΪ ʾĴĴ
static void DetectDisplay(uint8_t num);

static error_t errorList[errorListLength + 1];

#if INCLUDE_uxTaskGetStackHighWaterMark
uint32_t DetectTaskStack;
#endif

//ж
void DetectTask(void *pvParameters)
{
    static uint32_t systemTime;
    systemTime = xTaskGetTickCount();
    //ʼ
    DetectInit(systemTime);
    //һʱ
    vTaskDelay(DETECT_TASK_INIT_TIME);

    while (1)
    {
        static uint8_t error_num_display = 0;
        systemTime = xTaskGetTickCount();

        error_num_display = errorListLength;
        errorList[errorListLength].isLost = 0;
        errorList[errorListLength].errorExist = 0;

        for (int i = 0; i < errorListLength; i++)
        {
            //δʹܣ
            if (errorList[i].enable == 0)
            {
                continue;
            }

            //жϵ
            if (systemTime - errorList[i].newTime > errorList[i].setOfflineTime)
            {
                if (errorList[i].errorExist == 0)
                {
                    //¼Լʱ
                    errorList[i].isLost = 1;
                    errorList[i].errorExist = 1;
                    errorList[i].Losttime = systemTime;
                }
                //жϴȼ ȼߵĴ
                if (errorList[i].Priority > errorList[error_num_display].Priority)
                {
                    error_num_display = i;
                }
                //¼бĴڴ
                errorList[errorListLength].isLost = 1;
                errorList[errorListLength].errorExist = 1;
                //ṩн
                if (errorList[i].solveLostFun != NULL)
                {
                    errorList[i].solveLostFun();
                }
            }
            else if (systemTime - errorList[i].worktime < errorList[i].setOnlineTime)
            {
                //ոߣܴݲȶֻ¼ʧ
                errorList[i].isLost = 0;
                errorList[i].errorExist = 1;
            }
            else
            {
                errorList[i].isLost = 0;
                //жǷݴ
                if (errorList[i].dataIsError)
                {
                    errorList[i].errorExist = 1;
                }
                else
                {
                    errorList[i].errorExist = 0;
                }
                //Ƶ
                if (errorList[i].newTime > errorList[i].lastTime)
                {
                    errorList[i].frequency = configTICK_RATE_HZ / (fp32)(errorList[i].newTime - errorList[i].lastTime);
                }
            }
        }

        DetectDisplay(error_num_display + 1);
        vTaskDelay(DETECT_CONTROL_TIME);
#if INCLUDE_uxTaskGetStackHighWaterMark
        DetectTaskStack = uxTaskGetStackHighWaterMark(NULL);
#endif
    }
}

//ضӦ豸Ƿڴ
bool_t toe_is_error(uint8_t err)
{
    return (errorList[err].errorExist == 1);
}

//豸ݹӺ
void DetectHook(uint8_t toe)
{
    errorList[toe].lastTime = errorList[toe].newTime;
    errorList[toe].newTime = xTaskGetTickCount();
    //¶ʧ
    if (errorList[toe].isLost)
    {
        errorList[toe].isLost = 0;
        errorList[toe].worktime = errorList[toe].newTime;
    }
    //жǷ
    if (errorList[toe].dataIsErrorFun != NULL)
    {
        if (errorList[toe].dataIsErrorFun())
        {
            errorList[toe].errorExist = 1;
            errorList[toe].dataIsError = 1;

            if (errorList[toe].solveDataErrorFun != NULL)
            {
                errorList[toe].solveDataErrorFun();
            }
        }
        else
        {
            errorList[toe].dataIsError = 0;
        }
    }
    else
    {
        errorList[toe].dataIsError = 0;
    }
}
const error_t *getErrorListPoint(void)
{
    return errorList;
}
static void DetectDisplay(uint8_t num)
{
    static uint8_t last_num = errorListLength + 1;
    uint8_t i = 0;

    //8ˮʾǰ˵ĴSBUSңyaw.pitch,triger̨4̵
    for (i = 0; i <= ChassisMotor4TOE; i++)
    {
        if (errorList[i].errorExist)
        {
            DETECT_FLOW_LED_OFF(i);
        }
        else
        {
            DETECT_FLOW_LED_ON(i);
        }
    }

    // ͨ˸ж
    if (num == errorListLength + 1)
    {
        DETECT_LED_R_OFF();
        last_num = errorListLength + 1;
    }
    else
    {
        static uint8_t i = 0, led_flag = 0, cnt_num = 0, time = 0;
        //¼µȼĴ룬һ˸
        if (last_num != num)
        {
            last_num = num;
        }

        if (cnt_num == 0)
        {
            //cnt_num ¼м˸0һʱſʼһ
            time++;
            if (time > 50)
            {
                time = 0;
                cnt_num = last_num;
            }
            return;
        }

        if (i == 0)
        {

            DETECT_LED_R_TOGGLE();
            if (led_flag)
            {
                //һΣҪʣһ
                led_flag = 0;
                cnt_num--;
            }
            else
            {
                led_flag = 1;
            }
        }

        //iΪʱ20Ϊڣлһκ
        i++;

        if (i > 20)
        {
            i = 0;
        }
    }
}

static void DetectInit(uint32_t time)
{
    //ʱ䣬ȶʱ䣬ȼ offlineTime onlinetime priority
    uint16_t setItem[errorListLength][3] =
        {
            {30, 40, 15}, //SBUS
            {2, 3, 14},   //yaw
            {2, 3, 13},   //pitch
            {10, 10, 12}, //trigger
            {10, 10, 11}, //motor1
            {10, 10, 10}, //motor2
            {10, 10, 9},  //motor3
            {10, 10, 8},  //motor4

        };

    for (uint8_t i = 0; i < errorListLength; i++)
    {
        errorList[i].setOfflineTime = setItem[i][0];
        errorList[i].setOnlineTime = setItem[i][1];
        errorList[i].Priority = setItem[i][2];
        errorList[i].dataIsErrorFun = NULL;
        errorList[i].solveLostFun = NULL;
        errorList[i].solveDataErrorFun = NULL;

        errorList[i].enable = 1;
        errorList[i].errorExist = 1;
        errorList[i].isLost = 1;
        errorList[i].dataIsError = 1;
        errorList[i].frequency = 0.0f;
        errorList[i].newTime = time;
        errorList[i].lastTime = time;
        errorList[i].Losttime = time;
        errorList[i].worktime = time;
    }

    errorList[DBUSTOE].dataIsErrorFun = RC_data_is_error;
    errorList[DBUSTOE].solveLostFun = slove_RC_lost;
    errorList[DBUSTOE].solveDataErrorFun = slove_data_error;

#if GIMBAL_MOTOR_6020_CAN_LOSE_SLOVE
    errorList[YawGimbalMotorTOE].solveLostFun = GIMBAL_lose_slove;
    errorList[PitchGimbalMotorTOE].solveLostFun = GIMBAL_lose_slove;
#endif
}
